/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.TipoMovimiento;
import com.rjconsultores.ventaboletos.service.TipoMovimientoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarTipoMovimientoController")
@Scope("prototype")
public class EditarTipoMovimientoController extends MyGenericForwardComposer {

    @Autowired
    private TipoMovimientoService tipoMovimientoService;
    private TipoMovimiento tipoMovimiento;
    private MyListbox tipoMovimientoList;
    private Button btnApagar;
    private Textbox txtNome;
    private BusquedaTipoMovimientoController busquedaTipoMovimientoController;
    private static Logger log = Logger.getLogger(EditarTipoMovimientoController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public TipoMovimiento getTipoMovimiento() {
        return tipoMovimiento;
    }

    public void setTipoMovimiento(TipoMovimiento tipoMovimiento) {
        this.tipoMovimiento = tipoMovimiento;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
        busquedaTipoMovimientoController = (BusquedaTipoMovimientoController) Executions.getCurrent().getArg().get("busquedaTipoMovimientoController");
        tipoMovimiento = (TipoMovimiento) Executions.getCurrent().getArg().get("tipoMovimiento");
        tipoMovimientoList = (MyListbox) Executions.getCurrent().getArg().get("tipoMovimientoList");

        if (tipoMovimiento.getTipomovimientoId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();

        try {
            tipoMovimiento.setActivo(Boolean.TRUE);
            tipoMovimiento.setFecmodif(Calendar.getInstance().getTime());
            tipoMovimiento.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<TipoMovimiento> lsTipoMovimiento =
                    tipoMovimientoService.buscar(tipoMovimiento.getDescmovimiento());

            boolean podeSalvar = false;
            if (lsTipoMovimiento.isEmpty()) {
                podeSalvar = true;
            } else {
                if (tipoMovimiento.getTipomovimientoId() != null) {
                    for (TipoMovimiento p : lsTipoMovimiento) {
                        if (p.getTipomovimientoId().equals(tipoMovimiento.getTipomovimientoId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }

            if (!podeSalvar) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTipoMovimientoController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (tipoMovimiento.getTipomovimientoId() == null) {
                    tipoMovimientoService.suscribir(tipoMovimiento);
                    tipoMovimientoList.addItem(tipoMovimiento);
                } else {
                    tipoMovimientoService.actualizacion(tipoMovimiento);
                    tipoMovimientoList.updateItem(tipoMovimiento);
                }

                Messagebox.show(
                        Labels.getLabel("editarTipoMovimientoController.MSG.suscribirOK"),
                        Labels.getLabel("editarTipoMovimientoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                busquedaTipoMovimientoController.refreshLista();
                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarTipoMovimientoController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoMovimientoController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTipoMovimientoController.MSG.borrarPergunta"),
                    Labels.getLabel("editarTipoMovimientoController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                tipoMovimientoService.borrar(tipoMovimiento);

                Messagebox.show(
                        Labels.getLabel("editarTipoMovimientoController.MSG.borrarOK"),
                        Labels.getLabel("editarTipoMovimientoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tipoMovimientoList.removeItem(tipoMovimiento);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
